"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from formance_sdk_python.models.shared import (
    clientoptions as shared_clientoptions,
    createclientresponse as shared_createclientresponse,
)
from formance_sdk_python.types import BaseModel
from formance_sdk_python.utils import FieldMetadata, PathParamMetadata, RequestMetadata
import httpx
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class UpdateClientRequestTypedDict(TypedDict):
    client_id: str
    r"""Client ID"""
    client_options: NotRequired[shared_clientoptions.ClientOptionsTypedDict]


class UpdateClientRequest(BaseModel):
    client_id: Annotated[
        str,
        pydantic.Field(alias="clientId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Client ID"""

    client_options: Annotated[
        Optional[shared_clientoptions.ClientOptions],
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ] = None


class UpdateClientResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    create_client_response: NotRequired[
        shared_createclientresponse.CreateClientResponseTypedDict
    ]
    r"""Updated client"""


class UpdateClientResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    create_client_response: Optional[
        shared_createclientresponse.CreateClientResponse
    ] = None
    r"""Updated client"""
